###############################################
####
#### Sript produce Annotation files. 
####  There will be one annotation file SNP_annot_Version.csv  for Illumina platform (comma delimited)
####
####   Annotation file would contain 5 columns:
####  SNP annotation columns:    SNP_ID, Index, Chr_N(1-24), Chr_Arm(1,2), Position
####  
####  We will produce Annotations from one of the exports
####
###############################################


###############################################
### File paths and other parameters

### !!!!! Put the PATH to your data  !!!!

pPath<-"C:/GAP_Illumina_workflow_homepage/"

inputPath<-paste(pPath,"Exports/",sep="")
outputPath<-paste(pPath,"",sep="")


### !!!!! Correct the "Version" of Illimina, for example, Illum600k  !!!!
SNP_annot_fileName<-"SNP_annot_Version.csv"



###############################################
### Chromosome arm information

cyto_Band<-read.csv(paste(pPath,"cytoBand_adapted_fr_hg18.csv",sep=""),header=T,fill=T)
cyto_Band<-cyto_Band[order(cyto_Band$Chr_N,cyto_Band$Chr_arm,decreasing=F),]
cytoArm<-cyto_Band
for(k in 2:dim(cyto_Band)[[1]]){
if((cyto_Band$Chr_arm[k-1]==1)&&(cyto_Band$Chr_arm[k]==2)){cytoArm$Index[k-1]<-1
}else{cytoArm$Index[k]<-0}
}
cytoArm$Index[1]<-0
tt<-which(cytoArm$Index==0);if(length(tt)>0){cytoArm<-cytoArm[-tt,]}
tt<-which(cytoArm$Chr_arm==1);if(length(tt)>0){cytoArm<-cytoArm[-tt,]}

cytoArm<-cbind(cytoArm$Chr_N,cytoArm$Start)
colnames(cytoArm)<-c("Chr_N","Start_q")

###############################################


########### Reading your exports


### !!!!! Put your PATTERN<-"XXX", where XXX is some particular string from file names !!!!
### !!!!! Leave PATTERN="", if you process all files from Exports folder !!!!

PATTERN<-"_tQN"

segFiles <- list.files(inputPath,pattern=PATTERN, full.names=T) 

fileNames <- gsub(inputPath,"",segFiles) 

fileNames

nSample<-length(fileNames)

###############################################
### Reading file with sample names 


###################################################################
########### !!!!!!   !!!!!!!!!!!   !!!!!!!!!
###########
########### SNP_ID_column, the column in the Exports file with SNP IDs should be adjusted

SNP_ID_column<-1



ii<-1

print(ii)

## For exports with '#' character marking first lines to skip in export file
#aa<-scan(segFiles[ii],nlines=1,what="character",sep="\t")
#k<-1
#while((length(grep("#",aa))!=0)&&(grep("#",aa)==1)){
#aa<-scan(segFiles[ii],skip=k,nlines=1,what="character",sep="\t")
#k<-k+1
#}
#dataF<-read.delim(segFiles[ii],skip=k-1,header=T,fill=T,na.strings="null",row.names=SNP_ID_column)


## For the recent exports , 9 lines to skip, not including the Header
#k<-10
#dataF<-read.delim(segFiles[ii],skip=k-1,header=T,fill=T,na.strings="null",row.names=SNP_ID_column)

## If nothing to skip, header is the first line
k<-1
dataF<-read.delim(segFiles[ii],skip=k-1,header=T,fill=T,na.strings="null",row.names=SNP_ID_column)



colnames(dataF)
rownames(dataF)[1]

c_chr<-1
c_pos<-2


###################################################################
########### !!!!!!   !!!!!!!!!!!   !!!!!!!!!
###########
########### columns the matrix should be adjusted to the Exports file
###########  column c_chr=1 : chromosome 
###########  column c_pos=2 : position
###########   
########### If you have other column order, please, put their corresponding 


nSNP<-dim(dataF)[[1]]
Chr<-as.character(dataF[,c_chr])


###################################################################
########### !!!!!!   !!!!!!!!!!!   !!!!!!!!!
########### We rename chromosomes to be numbers
########### X 23, Y 24, M 25. In Illumina exports you can see XY for Y and MT for Mitochindria, 
###########    please, correct the 3 folowing rows, if necessary  


tt<-which(Chr=="X");if(length(tt)>0){Chr[tt]<-23}
tt<-which(Chr=="Y");if(length(tt)>0){Chr[tt]<-24}
tt<-which(Chr=="M");if(length(tt)>0){Chr[tt]<-25}
Chr<-as.numeric(Chr)

rNames<-as.character(rownames(dataF))
dataF<-cbind(seq(1,nSNP,1),Chr,Chr,dataF[,c_pos])
dataF<-data.matrix(dataF)
colnames(dataF)<-c("Index","Chr_N","Chr_arm","Position")
rownames(dataF)<-rNames

C_Ind<-1
C_Chr<-2
C_Arm<-3
C_Pos<-4


dataF[,C_Arm]<-1

chr<-1
for(chr in 1:dim(cytoArm)[[1]]){
	tt<-which(dataF[,C_Chr]==chr)
	if(length(tt)>0){
		qq<-which(dataF[tt,C_Pos]>=cytoArm[chr,2])
		if(length(qq)>0){dataF[tt[qq],C_Arm]<-2}
	}
}#chr


table(dataF[,C_Chr],dataF[,C_Arm])

SNP_annot<-dataF
rm(dataF)

SNP_annot<-SNP_annot[order(SNP_annot[,C_Chr],SNP_annot[,C_Pos],decreasing=F),]
SNP_annot[,1]<-seq(1,dim(SNP_annot)[[1]])


############### If saving SNP_annot and CN_annot


fName<-paste(pPath,SNP_annot_fileName,sep="")
write.table(SNP_annot, file = fName,quote=F,col.names=NA,row.names=T,sep=",")


########## END  ######################






